HDU 1025【最长上升子序列+时间优化】


传送门:HDU 1025


Constructing Roads In JGShining's Kingdom
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)

Problem Description
JGShining’s kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines.
Half of these cities are rich in resource (we call them rich cities) while the others are short of resource (we call them poor cities). Each poor city is short of exactly one kind of resource and also each rich city is rich in exactly one kind of resource. You may assume no two poor cities are short of one same kind of resource and no two rich cities are rich in one same kind of resource.
With the development of industry, poor cities wanna import resource from rich ones. The roads existed are so small that they’re unable to ensure the heavy trucks, so new roads should be built. The poor cities strongly BS each other, so are the rich ones. Poor cities don’t wanna build a road with other poor ones, and rich ones also can’t abide sharing an end of road with other rich ones. Because of economic benefit, any rich city will be willing to export resource to any poor one.
Rich citis marked from 1 to n are located in Line I and poor ones marked from 1 to n are located in Line II.
The location of Rich City 1 is on the left of all other cities, Rich City 2 is on the left of all other cities excluding Rich City 1, Rich City 3 is on the right of Rich City 1 and Rich City 2 but on the left of all other cities … And so as the poor ones.
But as you know, two crossed roads may cause a lot of traffic accident so JGShining has established a law to forbid constructing crossed roads.
For example, the roads in Figure I are forbidden.
在这里插入图片描述
In order to build as many roads as possible, the young and handsome king of the kingdom - JGShining needs your help, please help him. ^ _ ^

Input
Each test case will begin with a line containing an integer n(1 ≤ n ≤ 500,000). Then n lines follow. Each line contains two integers p and r which represents that Poor City p needs to import resources from Rich City r. Process to the end of file.

Output
For each test case, output the result in the form of sample.
You should tell JGShining what’s the maximal number of road(s) can be built.

Sample Input
2
1 2
2 1
3
1 2
2 3
3 1

Sample Output
Case 1:
My king, at most 1 road can be built.

Case 2:
My king, at most 2 roads can be built.

Hint
Huge input, scanf is recommended.




题解:
题目很好理解,看完题目很明显就是一个最长递增子序列的题。我们知道常规最长上升子序列的时间复杂度是O(n2),显示O(n2)的时间复杂度做这题是会超时的(n<=500,000)。所以这里就要用到最长上升序列的优化算法,时间复杂度为O(nlog n)。

回顾一下O(n2)的算法,a[t]表示数组中第t个数,dp[t]表示1到t这段中以a[t]为结尾的最长上升子序列的长度,状态转移方程为:dp[i]=max{1,1+dp[j]} (j=1……t-1,且a[i]>a[j]);

我们现在考虑dp[t]这个情况,我们有:
1.x<y<t;
2.a[x]<a[y]<a[t];
3.dp[x]=dp[y];

我们选择a[x]和a[y]都能得到相同的最长上升序列的长度,那么此时我们是选择a[x]还是a[y]呢?
显然是选择更小的a[x],因为这样可以为后面的数更多的空间。

再依据他们的dp值相同,我们可以得到一个想法:根据dp[]的值来分类。对于dp[]的值k,我们取满足dp[i]=k的最小a[i]。设D[k]记录这个值。

D[len] 表示最小的a[i]满足以a[i]为结尾的长度为len的最长上升子序列。
D[]的值是 单调的,即:D[1]<D[2]<D[3]<…

由上述的前提,优化后的方法为:设当前已知的最长上升子序列的长度为len,对于数a[i],
如果a[i]>D[len], 则a[i]应该接在长度为len的子序列后面,得D[len+1]=a[i];
如果a[i]<D[len], 在D[1]~D[len]中,找到第一个满足D[j]>=a[i]的数j,那么将a[i]作为长度为j的最长上升子序列的结尾,D[j]=a[i];
最后的len就是最长上升子序列的长度了。

如果在a[i]<D[len]时,普通的一遍遍历1~len,所需的时间复杂度仍是O(n2);所以我们可以用二分查找来优化他的时间,优化后的时间复杂度为O(nlog n)。


注:本题输出有个坑点,当最后len=1时,要输出的是road;当len>1时,输出roads。




AC代码:

#include<iostream>
#include<algorithm>
#include<cstring>
#include<cstdio>
#include<cmath>
#define ll long long
#define inf 0x3f3f3f3f
using namespace std;
const int N=510000;
int n,p,r;
int dp[N];//dp[i]=j,表示:已知最长上升子序列长度为i时,能成为该子序列结尾的最小数
int a[N];
int find(int x,int low,int high)//二分查找
{
  int mid;
  while(low<=high)
  {
    mid=(low+high)/2;
    if(dp[mid]<=a[x])
    {
      low=mid+1;
    }
    else
    {
      high=mid-1;
    }
  }
  return low;
}
int main()
{
  int ca=0;
  while(scanf("%d",&n)!=EOF)
  {
    memset(dp,0,sizeof(dp));
    for(int i=1;i<=n;i++)
    {
      scanf("%d%d",&p,&r);
      a[p]=r;
    }
    int len=0;//当前最长子序列的长度
    for(int i=1;i<=n;i++)
    {
      if(a[i]>dp[len])
      {
        dp[++len]=a[i];
      }
      else
      {
        int k=find(i,1,len);
        dp[k]=a[i];
      }
    }
    if(len==1)
    {
      printf("Case %d:\nMy king, at most 1 road can be built.\n\n",++ca);
    }
    else
    {
      printf("Case %d:\nMy king, at most %d roads can be built.\n\n",++ca,len);
    }
  }
  return 0;
}


这里附上O(n2)的最长上升子序列的代码:

#include<iostream>
using namespace std;
int main()
{
	int n;
	int a[1010];
	int dp[1010];//dp[i]=j,表示:在1···i中,以i为结尾的最长上升子序列的长度
	cin>>n;
	for(int i=1;i<=n;i++)
	{
		cin>>a[i];
	}
	dp[1]=1;
	for(int i=2;i<=n;i++)
	{
		int temp=0;
		for(int j=1;j<i;j++)
		{
			if(a[i]>a[j])
			{
				if(temp<dp[j])
				{
					temp=dp[j];
				}
			}
		}
		dp[i]=temp+1;
	}
	int MAX=0;
	for(int i=1;i<=n;i++)
	{
		if(MAX<dp[i])
		{
			MAX=dp[i];
		}
	}
	cout<<MAX<<endl;
	return 0;
}

  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值